import java.io.*;
import java_cup.runtime.Symbol;

%%
%eofval{ 
                    return symbol(CPUSymbol.EOF, 
                                  new Byte[0]
                                 );
%eofval}
%cup
%class CPU6502
%8bit

%int

%{
  private Symbol symbol(int type, Object value) {
    return new Symbol(type, yyline, yycolumn, value);
  }
  
  public static void main(String [] argv) {
    for (int i = 0; i < argv.length; i++) {
      try {
        System.out.print("["+argv[i]+"] is ");
        CPU6502 l = new CPU6502(new StraightStreamReader(new FileInputStream(argv[i])));
        l.yylex();
      }
      catch (Exception e) {
        e.printStackTrace(System.out);
        System.exit(1);
      }
    }
  }
%}

byte = \x00-\xFF
%%

\x69 {byte}       {
                    return symbol(CPUSymbol.ADC_ONE, 
                                  new Byte[] {
                                               new Byte((byte)yycharat(0)),
                                               new Byte((byte)yycharat(1))
                                             }
                                 );
                  }
\x6D {byte}{byte} {
                    return symbol(CPUSymbol.ADC_TWO, 
                                  new Byte[] {
                                               new Byte((byte)yycharat(0)),
                                               new Byte((byte)yycharat(1)),
                                               new Byte((byte)yycharat(2))
                                             }
                                 );
                  }
\x65 {byte}       {
                    return symbol(CPUSymbol.ADC_THREE, 
                                  new Byte[] {
                                               new Byte((byte)yycharat(0)),
                                               new Byte((byte)yycharat(1))
                                             }
                                 );
                  }

[^]               { System.out.println("illegal opcode"); }
